Index: trunk/kernel/vfs/fatfs.c
===================================================================
--- trunk/kernel/vfs/fatfs.c	(revision 1)
+++ trunk/kernel/vfs/fatfs.c	(revision 1)
@@ -0,0 +1,291 @@
+/*
+ * fatfs.c - FATFS file system API implementation.
+ *
+ * Author    Mohamed Lamine Karaoui (2015)
+ *           Alain Greiner (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+
+#include <hal_types.h>
+#include <hal_special.h>
+#include <printk.h>
+#include <kmem.h>
+#include <ppm.h>
+#include <vfs.h>
+#include <rpc.h>
+#include <mapper.h>
+#include <dev_ioc.h>
+#include <fatfs.h>
+
+
+//////////////////////////////////////////////////////////////////////////////////////////
+//////////////////////////////////////////////////////////////////////////////////////////
+// FATFS specific functions : these functions cannot be called by the VFS 
+//////////////////////////////////////////////////////////////////////////////////////////
+//////////////////////////////////////////////////////////////////////////////////////////
+
+//////////////////////////////////////////////////////////
+inline uint32_t fatfs_lba_from_cluster( fatfs_ctx_t * ctx,
+                                        uint32_t      cluster )
+{
+    return (ctx->cluster_begin_lba + ((cluster - 2) * ctx->sectors_per_cluster));
+}
+
+/////////////////////////////////////////////
+error_t fatfs_get_cluster( mapper_t * mapper,
+                           uint32_t   first_cluster,
+                           uint32_t   searched_page,
+                           uint32_t * cluster )
+{
+    page_t   * current_page_desc;      // pointer on current page descriptor
+    uint32_t * current_page_buffer;    // pointer on current page (array of uint32_t)
+    uint32_t   current_page_index;     // index of current page in mapper 
+    uint32_t   current_page_offset;    // offset of slot in current page
+    uint32_t   page_count_in_file;     // index of page in file (index in linked list)
+    uint32_t   current_cluster;        // content of current FAT slot
+
+    // compute number of FAT slots per PPM page
+    uint32_t slots_per_page = CONFIG_PPM_PAGE_SIZE >> 2;
+
+    // initialize loop variable
+    current_page_index  = first_cluster / slots_per_page;
+    current_page_offset = first_cluster % slots_per_page;
+    page_count_in_file  = 0;
+
+    // scan FAT (i.e. traverse FAT linked list)
+    while( page_count_in_file <= searched_page )
+    {
+        // get pointer on current page descriptor
+        current_page_desc = mapper_get_page( mapper , current_page_index );
+
+        if( current_page_desc == NULL ) return EIO;
+
+        // get pointer on buffer for current page
+        current_page_buffer = (uint32_t *)ppm_page2base( current_page_desc );
+
+        // get FAT slot content 
+        current_cluster = current_page_buffer[current_page_offset];
+
+        // update loop variables
+        current_page_index  = current_cluster / slots_per_page;
+        current_page_offset = current_cluster % slots_per_page;
+        page_count_in_file++;
+    }
+    
+    // return success
+    *cluster = current_cluster;
+    return 0;
+
+}  // end fatfs_get_cluster()
+
+
+////////////////////////////////////////////////////////////////////////////////////////
+// This function returns the FATFS cluster index of a page identified by its page
+// index in the file, using the FAT mapper. It scans the FAT mapper, starting from the
+// FATFS cluster index allocated to the first page of the file, until it reaches the 
+// searched page. The FAT mapper is automatically updated in case of miss. 
+// This function can be called by any thread running in any cluster, as it uses the
+// RPC_FATFS_GET_CLUSTER to access the remote FAT mapper if required.
+// We use a RPC to scan the FAT because the RPC_FIFO will avoid contention
+// in the cluster containing the FAT mapper, and the RPC latency is not critical
+// compared to the device access latency.
+////////////////////////////////////////////////////////////////////////////////////////
+// @ ctx	       : pointer on local FATFS context.
+// @ first_cluster : first cluster allocated to a file in FATFS.
+// @ page_index    : index of searched page in file (one page occupies one cluster).
+// @ cluster_index : [out] pointer on buffer for FATFS cluster index.
+// @ return 0 if success / return EIO if a FAT cluster miss cannot be solved.
+////////////////////////////////////////////////////////////////////////////////////////
+static error_t fatfs_cluster_from_index( fatfs_ctx_t * ctx,
+                                         uint32_t      first_cluster,
+                                         uint32_t      page_index,
+                                         uint32_t    * cluster_index )
+{
+    uint32_t searched_cluster;   // searched FATFS cluster index
+    error_t  error;
+
+    // get extended pointer on FAT mapper
+    xptr_t fat_mapper_xp = ctx->fat_mapper_xp;
+
+    // get cluster cxy and local pointer on FAT mapper
+    cxy_t      fat_mapper_cxy = GET_CXY( fat_mapper_xp );
+    mapper_t * fat_mapper_ptr = (mapper_t *)GET_PTR( fat_mapper_xp );
+
+    if( fat_mapper_cxy == local_cxy )    // FAT mapper is local
+    {
+        error = fatfs_get_cluster( fat_mapper_ptr,
+                                   first_cluster,
+                                   page_index,
+                                   &searched_cluster );
+    }
+    else                                 // FAT mapper is remote
+    {
+        rpc_fatfs_get_cluster_client( fat_mapper_cxy,
+                                      fat_mapper_ptr,
+                                      first_cluster,
+                                      page_index,
+                                      &searched_cluster,
+                                      &error );
+    }
+    
+    if( error )
+    {
+        printk("\n[ERROR] in %s : cannot access FAT\n", __FUNCTION__ );
+        return error;
+    }
+
+    // return success
+    *cluster_index = searched_cluster;
+    return 0;
+
+}  // end fatfs_cluster_from_index()
+
+
+
+
+///////////////////////////////////////////////////////////////////////////////////////
+///////////////////////////////////////////////////////////////////////////////////////
+// Generic API : the following functions are called by the VFS, 
+//               and must be defined by all isupported file systems.
+///////////////////////////////////////////////////////////////////////////////////////
+///////////////////////////////////////////////////////////////////////////////////////
+
+////////////////////////////////////////////////////////////
+error_t fatfs_inode_create( struct vfs_inode_s * vfs_inode )
+{
+    printk("\n[PANIC] %s not fully implemented yet\n", __FUNCTION__ );
+    hal_core_sleep();
+
+    kmem_req_t      req;
+    fatfs_inode_t * fatfs_inode;
+
+    // allocate memory for fatfs inode
+	req.type    = KMEM_FATFS_INODE;
+	req.size    = sizeof(fatfs_inode_t);
+    req.flags   = AF_KERNEL | AF_ZERO;
+	fatfs_inode = (fatfs_inode_t *)kmem_alloc( &req );
+
+    if( fatfs_inode == NULL ) return ENOMEM;
+
+    // initialise ramfs_inode 
+    fatfs_inode->first_cluster = 0;   // TODO ???
+    fatfs_inode->ctx           = (fatfs_ctx_t *)vfs_inode->ctx->extend;
+ 
+    // link fatfs_inode to vfs_inode
+    vfs_inode->extend = fatfs_inode;
+
+    return 0;
+
+}
+
+//////////////////////////////////////////////////////
+void fatfs_inode_destroy( struct vfs_inode_s * inode )
+{
+    printk("\n[PANIC] %s not fully implemented yet\n", __FUNCTION__ );
+    hal_core_sleep();
+}
+
+//////////////////////////////////////////////////
+error_t fatfs_ctx_create( struct vfs_ctx_s * ctx )
+{
+    printk("\n[PANIC] %s not fully implemented yet\n", __FUNCTION__ );
+    hal_core_sleep();
+
+    return 0;
+}
+
+////////////////////////////////////////////////
+void fatfs_ctx_destroy( struct vfs_ctx_s * ctx )
+{
+    printk("\n[PANIC] %s not fully implemented yet\n", __FUNCTION__ );
+    hal_core_sleep();
+}
+
+////////////////////////////////////////////////
+static error_t fatfs_access_page( page_t * page,
+                                  bool_t   is_read )
+{
+    // get source buffer base address
+    char * buffer = (char *)ppm_page2base( page );
+ 
+    // get pointer on source mapper and page index from page descriptor
+    mapper_t * src_mapper  = page->mapper;
+    uint32_t   page_index  = page->index;
+
+    if( src_mapper == NULL)
+    {
+        printk("\n[PANIC] in %s : no mapper for this page\n", __FUNCTION__ );
+        hal_core_sleep();
+    }
+
+    // get VFS inode pointer from mapper
+    vfs_inode_t * vfs_inode = src_mapper->inode;
+
+    // get FATFS inode pointer for VFS inode
+    fatfs_inode_t * fatfs_inode = (fatfs_inode_t *)vfs_inode->extend;
+
+    // get first cluster index from FATFS inode
+    uint32_t  first_cluster = fatfs_inode->first_cluster;
+
+    // get FATFS context pointer from FATFS inode
+    fatfs_ctx_t * fatfs_ctx = fatfs_inode->ctx;
+
+    // get number of sectors 
+    uint32_t count = fatfs_ctx->sectors_per_cluster;
+
+    // compute FATFS_cluster index for the accessed page
+    uint32_t cluster;
+    error_t  error = fatfs_cluster_from_index( fatfs_ctx,
+                                               first_cluster,
+                                               page_index,
+                                               &cluster );
+    if( error ) return EIO;
+
+    // get lba from cluster
+    uint32_t lba = fatfs_lba_from_cluster( fatfs_ctx , cluster );
+
+    // access device
+    if( is_read ) error = dev_ioc_read ( buffer , lba , count );
+    else          error = dev_ioc_write( buffer , lba , count );     
+
+    if( error )
+    {
+        printk("\n[ERROR] in %s : cannot access IOC device\n", __FUNCTION__ );
+        return error;
+    } 
+
+    // successful access 
+    return 0;
+}
+
+////////////////////////////////////////////////
+error_t fatfs_write_page( struct page_s * page )
+{
+    bool_t is_read = false;
+    return fatfs_access_page( page , is_read );
+}
+
+///////////////////////////////////////////////
+error_t fatfs_read_page( struct page_s * page )
+{
+    bool_t is_read = true;
+    return fatfs_access_page( page , is_read );
+}
+
Index: trunk/kernel/vfs/fatfs.h
===================================================================
--- trunk/kernel/vfs/fatfs.h	(revision 1)
+++ trunk/kernel/vfs/fatfs.h	(revision 1)
@@ -0,0 +1,162 @@
+/*
+ * fatfs.h - FATFS file system API definition.
+ *
+ * Author    Mohamed Lamine Karaoui (2015)
+ *           Alain Greiner (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _FATFS_H_
+#define _FATFS_H_
+
+#include <hal_types.h>
+#include <rwlock.h>
+
+/****  Forward declarations  ****/
+
+struct mapper_s;
+struct device_s;
+struct vfs_inode_s;
+struct vfs_ctx_s;
+struct page_s;
+
+/*****************************************************************************************
+ * This structure defines a FATFS specific context extension. 
+ ****************************************************************************************/
+
+typedef struct fatfs_ctx_s
+{
+    rwlock_t          lock;                  /*! TODO protect what ???                  */
+    uint32_t          fat_begin_lba;         /*! first lba of FAT region                */
+    uint32_t          fat_sectors_count;     /*! number of sectors in FAT region        */
+    uint32_t          bytes_per_sector;      /*!                                        */
+    uint32_t          bytes_per_cluster;     /*!                                        */
+    uint32_t          cluster_begin_lba;     /*! first lba of data region on device     */
+    uint32_t          sectors_per_cluster;   /*!                                        */
+    uint32_t          rootdir_first_cluster; /*                                         */
+    uint32_t          last_allocated_sector; /*!                                        */
+    uint32_t          last_allocated_index;  /*! TODO last allocated cluster ???        */
+    xptr_t            fat_mapper_xp;         /*! FAT mapper (in IO cluster)             */ 
+}
+fatfs_ctx_t;
+
+/*****************************************************************************************
+ * This structure defines the FAT specific inode extension (versus the VFS inode).
+ ****************************************************************************************/
+
+typedef struct fatfs_inode_s
+{
+    struct fatfs_ctx_s * ctx;                /*! local pointer on the FATFS context     */ 
+	uint32_t             first_cluster;      /*! first cluster for this file/dir        */ 
+}
+fatfs_inode_t;
+
+
+
+/*****************************************************************************************
+ * This function returns the LBA of the first sector of a FAT cluster.
+ * This function can be called by any thread running in any cluster.
+ *****************************************************************************************
+ * @ ctx	  :	pointer on FATFS context.
+ * @ cluster  :	cluster index in FATFS.
+ * # return the lba value.
+ ****************************************************************************************/
+inline uint32_t fatfs_lba_from_cluster( fatfs_ctx_t * ctx,
+                                        uint32_t      cluster );
+
+/*****************************************************************************************
+ * This function scan the FAT (File Allocation Table), stored in the FAT mapper,
+ * and return the FATFS cluster index for a given page of a given file.
+ * It must be called by a thread running in the cluster containing the FAT mapper
+ * (can be a local thread or a RPC thread).
+ * The FAT is actually an array of uint32_t slots. Each slot in this array contains the 
+ * index of another slot in this array, to form one linked list for each file stored on
+ * device in the RAMFS file system. This index in the FAT array is also the index of the
+ * FATFS cluster on the device. One FATFS cluster is supposed to contain one PPM page. 
+ * For a given file, the entry point in the FAT is simply the index of the FATFS cluster 
+ * containing the first page of the file. The mapper being a cache, this function 
+ * automatically updates the FAT mapper from informations stored on device in case of miss.
+ *****************************************************************************************
+ * @ mapper	 : local pointer on the FAT mapper.
+ * @ first	 : index of the first FATFS cluster allocated to the file.
+ * @ page    : index of searched page in the file.
+ * @ cluster : [out] pointer on buffer for the found FATFS cluster index.
+ * @ return 0 if success / return EIO if FAT mapper miss cannot be solved.
+ ****************************************************************************************/
+error_t fatfs_get_cluster( struct mapper_s * mapper,
+                           uint32_t          first_cluster,
+                           uint32_t          searched_page,
+                           uint32_t        * cluster );
+
+/*****************************************************************************************
+ * This function allocates memory for a FATFS inode, initializes it,
+ * and link it to the VFS inode.
+ *****************************************************************************************
+ * @ inode   : local pointer on vfs_inode.
+ * @ return 0 if success / return ENOMEM if error. 
+ ****************************************************************************************/
+error_t fatfs_inode_create( struct vfs_inode_s * inode );
+
+/*****************************************************************************************
+ * This function releases memory allocated for a FATFS inode.
+ *****************************************************************************************
+ * @ inode   : local pointer on vfs_inode.
+ ****************************************************************************************/
+void fatfs_inode_destroy( struct vfs_inode_s * inode );
+
+/*****************************************************************************************
+ * This function allocates memory for a FATFS context, initialises it, 
+ * and link it to the local VFS context.
+ *****************************************************************************************
+ * @ inode   : local pointer on VFS context.
+ * @ return 0 if success / return ENOMEM if error. 
+ ****************************************************************************************/
+error_t fatfs_ctx_create( struct vfs_ctx_s * ctx );
+
+/*****************************************************************************************
+ * This function releases memory allocated for a FATFS context.
+ *****************************************************************************************
+ * @ ctx   : local pointer on VFS context.
+ ****************************************************************************************/
+void fatfs_ctx_destroy( struct vfs_ctx_s * ctx );
+
+/*****************************************************************************************
+ * This function moves a page from the mapper to the FATFS file system.
+ * It must be called by a thread running in cluster containing the mapper.
+ * The pointer on the mapper and the page index in file are supposed to be registered
+ * in the page descriptor. 
+ *****************************************************************************************
+ * @ page    : local pointer on page descriptor.
+ * @ return 0 if success / return EIO if error. 
+ ****************************************************************************************/
+error_t fatfs_write_page( struct page_s * page );
+
+/*****************************************************************************************
+ * This function moves a page from the FATFS file system on device to the mapper.
+ * It must be called by a thread running in cluster containing the mapper.
+ * The pointer on the mapper and the page index in file are supposed to be registered
+ * in the page descriptor. 
+ *****************************************************************************************
+ * @ page    : local pointer on page descriptor.
+ * @ return 0 if success / return EIO if error. 
+ ****************************************************************************************/
+error_t fatfs_read_page( struct page_s * page );
+
+
+#endif	/* _FATFS_H_ */
Index: trunk/kernel/vfs/ramfs.c
===================================================================
--- trunk/kernel/vfs/ramfs.c	(revision 1)
+++ trunk/kernel/vfs/ramfs.c	(revision 1)
@@ -0,0 +1,96 @@
+/*
+ * ramfs.c  RAMFS file system API implementation.
+ *
+ * Authors   Mohamed Lamine Karaoui (2015)
+ *           Alain Greiner (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+
+#include <hal_types.h>
+#include <hal_special.h>
+#include <printk.h>
+#include <kmem.h>
+#include <vfs.h>
+#include <ramfs.h>
+
+
+///////////////////////////////////////////////////////////////////////////////////////
+// RAMFS specific functions : these static functions cannot be called by the VFS 
+///////////////////////////////////////////////////////////////////////////////////////
+
+
+
+///////////////////////////////////////////////////////////////////////////////////////
+// Generic API : the following functions are called by the VFS, 
+//               and must be defined by all supported file systems.
+///////////////////////////////////////////////////////////////////////////////////////
+
+////////////////////////////////////////////////////////////
+error_t ramfs_inode_create( struct vfs_inode_s * vfs_inode )
+{
+    printk("\n[PANIC] %s not fully implemented yet\n", __FUNCTION__ );
+    hal_core_sleep();
+
+    kmem_req_t      req;
+    ramfs_inode_t * ramfs_inode;
+
+    // allocate memory for ramfs inode
+	req.type    = KMEM_RAMFS_INODE;
+	req.size    = sizeof(ramfs_inode_t);
+    req.flags   = AF_KERNEL | AF_ZERO;
+	ramfs_inode = (ramfs_inode_t *)kmem_alloc( &req );
+
+    if( ramfs_inode == NULL ) return ENOMEM;
+
+    // initialise ramfs_inode TODO
+
+    // link vfs_inode to ramfs_inode
+    vfs_inode->extend = ramfs_inode;
+
+    return 0;
+}
+
+//////////////////////////////////////////////////////
+void ramfs_inode_destroy( struct vfs_inode_s * inode )
+{
+    printk("\n[PANIC] %s not fully implemented yet\n", __FUNCTION__ );
+    hal_core_sleep();
+
+    return 0;
+}
+
+/////////////////////////////////////////////////
+error_t ramfs_write_page( struct page_s  * page )
+{
+    printk("\n[PANIC] %s not fully implemented yet\n", __FUNCTION__ );
+    hal_core_sleep();
+
+    return 0;
+}
+
+////////////////////////////////////////////////
+error_t ramfs_read_page( struct page_s  * page )
+{
+    printk("\n[PANIC] %s not fully implemented yet\n", __FUNCTION__ );
+    hal_core_sleep();
+
+    return 0;
+}
+   
Index: trunk/kernel/vfs/ramfs.h
===================================================================
--- trunk/kernel/vfs/ramfs.h	(revision 1)
+++ trunk/kernel/vfs/ramfs.h	(revision 1)
@@ -0,0 +1,96 @@
+/*
+ * ramfs.h  RAMFS file system API definition.
+ *
+ * Authors   Mohamed Lamine Karaoui (2015)
+ *           Alain Greiner (2016)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _RAMFS_H_
+#define _RAMFS_H_
+
+/****  Forward declarations  ****/
+
+struct vfs_inode_s;
+struct page_s;
+
+/*****************************************************************************************
+ * This structure defines a RAMFS specific context extension. 
+ ****************************************************************************************/
+
+typedef struct ramfs_ctx_s
+{
+    intptr_t          base;                                                                 
+    rwlock_t          size;
+}
+ramfs_ctx_t;
+
+/*****************************************************************************************
+ * This structure defines the RAMFS inode specific extension (versus the VFS inode).
+ ****************************************************************************************/
+
+typedef struct ramfs_inode_s
+{
+    struct vfs_inode_s * vfs_inode;   /*! local pointer on VFS inode                    */
+}
+ramfs_inode_t;
+
+
+
+
+/*****************************************************************************************
+ * This function allocates memory for a RAMFS inode, and link it to the VFS inode.
+ *****************************************************************************************
+ * @ inode   : local pointer on vfs_inode.
+ * @ return 0 if success / return ENOMEM if error. 
+ ****************************************************************************************/
+error_t ramfs_inode_create( struct vfs_inode_s * inode );
+
+/*****************************************************************************************
+ * This function releases memory allocated for a RAMFS inode.
+ *****************************************************************************************
+ * @ inode   : local pointer on vfs_inode.
+ ****************************************************************************************/
+void ramfs_inode_destroy( struct vfs_inode_s * inode );
+
+/*****************************************************************************************
+ * This function moves a page from the mapper to the RAMFS file system.
+ * It must be called by a thread running in cluster containing the mapper.
+ * The pointer on the mapper and the page index in file are supposed to be registered
+ * in the page descriptor. 
+******************************************************************************************
+ * @ page    : local pointer on source page descriptor.
+ * @ return 0 if success / return EIO if error. 
+ ****************************************************************************************/
+error_t ramfs_write_page( struct page_s  * page );
+
+/*****************************************************************************************
+ * This function moves a page from the RAMFS file system to the mapper.
+ * It must be called by a thread running in cluster containing the mapper.
+ * The pointer on the mapper and the page index in file are supposed to be registered
+ * in the page descriptor. 
+ *****************************************************************************************
+ * @ page    : local pointer on destination page descriptor.
+ * @ return 0 if success / return EIO if error. 
+ ****************************************************************************************/
+error_t ramfs_read_page( struct page_s  * page );
+
+
+   
+#endif	/* _RAMFS_H_ */
